#define BOUNDS_CHK
#define VOID_CHK
#define WHEN_CHK
#define RETURN_CHK
#include "sather.h"

/* Layouts */

typedef struct dCALL_TP_struct {
 OB_HEADER header;
 } *dCALL_TP;

typedef struct dSTR_struct {
 OB_HEADER header;
 } *dSTR;

typedef struct dTP_struct {
 OB_HEADER header;
 } *dTP;

typedef struct ARRAYdCALL_TP_struct {/* layout for ARRAY{$CALL_TP} */
 OB_HEADER header;
 INT asize;
 struct dCALL_TP_struct *arr_part[1];
 } *ARRAYdCALL_TP;


typedef struct ARRAYdCALL_TP_eltb_dCALL_frame_struct {
 ARRAYdCALL_TP self;/* Formal argument: self */
 INT state;
 dCALL_TP ret_val;
 ARRAYdCALL_TP L31;
 struct ARRAYdCALL_TP_aeltb_dCAL_frame_struct *nested1; /* nested iter frame */
 } *ARRAYdCALL_TP_eltb_dCALL_frame;

typedef struct ARRAYdTP_struct {/* layout for ARRAY{$TP} */
 OB_HEADER header;
 INT asize;
 struct dTP_struct *arr_part[1];
 } *ARRAYdTP;


typedef struct ARRAYdTP_eltb_dTP_frame_struct {
 ARRAYdTP self;/* Formal argument: self */
 INT state;
 dTP ret_val;
 ARRAYdTP L31;
 struct ARRAYdTP_aeltb_dTP_frame_struct *nested1; /* nested iter frame */
 } *ARRAYdTP_eltb_dTP_frame;

typedef struct CALL_TP_ARRAY_struct {/* layout for CALL_TP_ARRAY */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *CALL_TP_ARRAY;

typedef struct CALL_TP_CREATE_struct {/* layout for CALL_TP_CREATE */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *CALL_TP_CREATE;

typedef struct CALL_TP_UNDERSCORE_struct {/* layout for CALL_TP_UNDERSCORE */
 OB_HEADER header;
 struct dTP_struct *tp1;
 } *CALL_TP_UNDERSCORE;

typedef struct CALL_TP_VOID_struct {/* layout for CALL_TP_VOID */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *CALL_TP_VOID;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct IFC_struct {/* layout for IFC */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct SIG_TBL_struct *sigs1;
 } *IFC;

typedef struct IFC_TBL_struct {/* layout for IFC_TBL */
 OB_HEADER header;
 struct FMAPdTPIFC_struct *tbl;
 struct FSETTUPIDENTINT_struct *abs_cur;
 struct PROG_struct *prog1;
 } *IFC_TBL;

typedef struct IMPL_struct {/* layout for IMPL */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ELT_TBL_struct *elts;
 struct IFC_struct *ifc;
 struct TP_CLASS_struct *arr1;
 } *IMPL;

typedef struct IMPL_TBL_struct {/* layout for IMPL_TBL */
 OB_HEADER header;
 struct FMAPdTPIMPL_struct *tbl;
 struct FSETTUPIDENTINT_struct *cur;
 struct PROG_struct *prog1;
 } *IMPL_TBL;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct SIG_struct {/* layout for SIG */
 OB_HEADER header;
 struct dTP_struct *ret1;
 struct dTP_struct *tp;
 struct ARRAYdTP_struct *args1;
 struct ARRAYBOOL_struct *hot;
 struct IDENT_struct name1;
 STR str;
 BOOL am_created;
 BOOL is_forked;
 BOOL needs_export;
 BOOL needs_import;
 } *SIG;


typedef struct STR_separateb_STR_STR_frame_struct {
 STR self;/* Formal argument: self */
 STR arg1;/* Formal argument: s */
 INT state;
 STR ret_val;
 } *STR_separateb_STR_STR_frame;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_ITER_struct {/* layout for TP_ITER */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct ARRAYBOOL_struct *hot;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ITER;

typedef struct TP_ROUT_struct {/* layout for TP_ROUT */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ROUT;

typedef struct CALL_SIG_struct {/* layout for CALL_SIG */
 OB_HEADER header;
 struct dTP_struct *tp1;
 struct ARRAYdCALL_TP_struct *args1;
 struct IDENT_struct name1;
 BOOL has_ret;
 BOOL unknown_ret;
 } *CALL_SIG;

typedef struct FSTR_struct {/* layout for FSTR */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FSTR;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;

#include "tags.h"

/* Globals */

extern CALL_TP_ARRAY CALL_TP_ARRAY_cache;
extern CALL_TP_CREATE CALL_TP_CREATE_cache;
extern CALL_TP_VOID CALL_TP_VOID_cache;
extern IDENT IDENT_BUILTIN_call_bang_1;
extern IDENT IDENT_BUILTIN_call_ident1;

/* Function declarations */

BOOL CALL_SIG_conforms_to_SIG(CALL_SIG, SIG);
BOOL CALL_TP_ARRAY_is_subtype(CALL_TP_ARRAY, dTP);
BOOL CALL_TP_CREATE_is_subtyp(CALL_TP_CREATE, dTP);
BOOL CALL_TP_UNDERSCORE_is_su(CALL_TP_UNDERSCORE, dTP);
BOOL CALL_TP_VOID_is_subtype_(CALL_TP_VOID, dTP);
BOOL IDENT_is_eq_IDENT_BOOL(IDENT, IDENT);
BOOL IDENT_is_neq_IDENT_BOOL(IDENT, IDENT);
CALL_SIG CALL_SIG_create_CALL_SIG(CALL_SIG);
CALL_TP_ARRAY CALL_TP_ARRAY_create_CAL(CALL_TP_ARRAY);
CALL_TP_CREATE CALL_TP_CREATE_create_CA(CALL_TP_CREATE);
CALL_TP_UNDERSCORE CALL_TP_UNDERSCORE_creat(CALL_TP_UNDERSCORE);
CALL_TP_VOID CALL_TP_VOID_create_CALL(CALL_TP_VOID);
FSTR FSTR_create_FSTR(FSTR);
FSTR FSTR_plus_CHAR_FSTR(FSTR, CHAR);
FSTR FSTR_plus_STR_FSTR(FSTR, STR);
IDENT IDENT_create_STR_IDENT(IDENT, STR);
IFC IFC_TBL_ifc_of_dTP_IFC(IFC_TBL, dTP);
IMPL IMPL_TBL_impl_of_dTP_IMP(IMPL_TBL, dTP);
INT ARRAYdCALL_TP_size_INT(ARRAYdCALL_TP);
INT ARRAYdTP_size_INT(ARRAYdTP);
PROG CALL_SIG_prog_PROG(CALL_SIG);
SIG CALL_SIG_lookup_BOOL_SIG(CALL_SIG, BOOL);
SIG IFC_sig_for_call_CALL_SI(IFC, CALL_SIG);
SIG IMPL_sig_for_internal_ca(IMPL, CALL_SIG);
SIG SIG_bound_iter_call_TP_I(SIG, TP_ITER);
SIG SIG_bound_routine_call_T(SIG, TP_ROUT);
STR CALL_SIG_str_STR(CALL_SIG);
STR CALL_TP_ARRAY_str_STR(CALL_TP_ARRAY);
STR CALL_TP_CREATE_str_STR(CALL_TP_CREATE);
STR CALL_TP_UNDERSCORE_str_S(CALL_TP_UNDERSCORE);
STR CALL_TP_VOID_str_STR(CALL_TP_VOID);
STR FSTR_str_STR(FSTR);
STR STR_plus_dSTR_STR(STR, dSTR);
STR STR_separateb_STR_STR(STR_separateb_STR_STR_frame);
STR TP_ITER_str_STR(TP_ITER);
STR TP_ROUT_str_STR(TP_ROUT);
dCALL_TP ARRAYdCALL_TP_eltb_dCALL(ARRAYdCALL_TP_eltb_dCALL_frame);
dTP ARRAYdTP_eltb_dTP(ARRAYdTP_eltb_dTP_frame);
extern const int dCALL_TP_is_subtype_dTP__offset;

extern const BOOL (*dCALL_TP_is_subtype_dTP_[])(dCALL_TP, dTP);
extern const int dCALL_TP_str_STR_offset;

extern const STR (*dCALL_TP_str_STR[])(dCALL_TP);
extern const int dTP_is_neq_dTP_BOOL_offset;

extern const BOOL (*dTP_is_neq_dTP_BOOL[])(dTP, dTP);
extern const int dTP_is_subtype_dTP_BOOL_offset;

extern const BOOL (*dTP_is_subtype_dTP_BOOL[])(dTP, dTP);
extern const int dTP_kind_INT_offset;

extern const INT (*dTP_kind_INT[])(dTP);
extern const int dTP_prog_PROG_offset;

extern const PROG (*dTP_prog_PROG[])(dTP);
extern const int dTP_str_STR_offset;

extern const STR (*dTP_str_STR[])(dTP);
void CALL_TP_ARRAY_cache_CALL(CALL_TP_ARRAY, CALL_TP_ARRAY);
void CALL_TP_CREATE_cache_CAL(CALL_TP_CREATE, CALL_TP_CREATE);
void CALL_TP_VOID_cache_CALL_(CALL_TP_VOID, CALL_TP_VOID);
void PROG_err_STR(PROG, STR);

/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


/* Code */




BOOL CALL_SIG_conforms_to_SIG(CALL_SIG self, SIG s) {
 BOOL ret_val = ((BOOL) 0);
 ARRAYdCALL_TP L11;
 dCALL_TP ca;
 ARRAYdTP L21;
 dTP sa1;
 BOOL L3;
 dTP L4;
 BOOL L5;
 BOOL L6;
 INT L7;
 INT L8;
 dCALL_TP L9;
 dTP L10;
 dCALL_TP L12;
 BOOL L13;
 if ((self==((CALL_SIG) NULL))) {
  L3 = TRUE;
 } else {
  L3 = (s==((SIG) NULL));
 }
 if (L3) {
  ret_val = FALSE;
  return ret_val;
 }
 L4 = ATTR(self,tp1);
 if (L4==NULL) {
  FATAL("Dispatch on void in CALL_SIG::conforms_to(SIG):BOOL");
 }
 if ((*dTP_is_neq_dTP_BOOL[TAG(L4)+dTP_is_neq_dTP_BOOL_offset])(L4, ATTR(s,tp))) {
  ret_val = FALSE;
  return ret_val;
 }
 if (IDENT_is_neq_IDENT_BOOL(ATTR(self,name1), ATTR(s,name1))) {
  ret_val = FALSE;
  return ret_val;
 }
 L5 = ATTR(self,unknown_ret);
 if ((!(L5))) {
  if (ATTR(self,has_ret)) {
   if ((ATTR(s,ret1)==((dTP) NULL))) {
    ret_val = FALSE;
    return ret_val;
   }
  }
  else {
   L6 = (ATTR(s,ret1)==((dTP) NULL));
   if ((!(L6))) {
    ret_val = FALSE;
    return ret_val;
   }
  }
 }
 L7 = ARRAYdCALL_TP_size_INT(ATTR(self,args1));
 L8 = ARRAYdTP_size_INT(ATTR(s,args1));
 if ((L7!=L8)) {
  ret_val = FALSE;
  return ret_val;
 }
 {
  struct ARRAYdCALL_TP_eltb_dCALL_frame_struct other1_0;
  ARRAYdCALL_TP_eltb_dCALL_frame 
  noname1 = &other1_0;
  struct ARRAYdTP_eltb_dTP_frame_struct other1_1;
  ARRAYdTP_eltb_dTP_frame 
  noname2 = &other1_1;
  noname1->state = 0;
  noname2->state = 0;
  while (1) {
   if (noname1->state == 0) {
    L11 = ATTR(self,args1);
    noname1->self = L11;
   }
   L9 = ARRAYdCALL_TP_eltb_dCALL(noname1);
   if (noname1->state == -1) {
    goto after_loop;
   }
   ca = L9;
   if (noname2->state == 0) {
    L21 = ATTR(s,args1);
    noname2->self = L21;
   }
   L10 = ARRAYdTP_eltb_dTP(noname2);
   if (noname2->state == -1) {
    goto after_loop;
   }
   sa1 = L10;
   L12 = ca;
   if (L12==NULL) {
    FATAL("Dispatch on void in CALL_SIG::conforms_to(SIG):BOOL");
   }
   L13 = (*dCALL_TP_is_subtype_dTP_[TAG(L12)+dCALL_TP_is_subtype_dTP__offset])(L12, sa1);
   if ((!(L13))) {
    ret_val = FALSE;
    return ret_val;
   }
  }
 }
 after_loop: ;
 ret_val = TRUE;
 return ret_val;
}


BOOL CALL_TP_ARRAY_is_subtype(CALL_TP_ARRAY self, dTP t) {
 BOOL ret_val = ((BOOL) 0);
 IDENT L1;
 extern STR ARRAY;
 if (t==NULL) {
  ret_val = FALSE;
  return ret_val;
 } else
 switch (TAG(t)) {
  case TP_CLASS_tag:
   L1 = ATTR(((TP_CLASS) t),name1);
   ret_val = IDENT_is_eq_IDENT_BOOL(L1, IDENT_create_STR_IDENT(IDENT_zero, ((STR) &ARRAY)));
   return ret_val; break;
  default: ;
   ret_val = FALSE;
   return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CALL_TP_CREATE_is_subtyp(CALL_TP_CREATE self, dTP t) {
 BOOL ret_val = ((BOOL) 0);
 INT L11 = ((INT) 0);
 dTP L2;
 L2 = t;
 if (L2==NULL) {
  FATAL("Dispatch on void in CALL_TP_CREATE::is_subtype($TP):BOOL");
 }
 L11 = (*dTP_kind_INT[TAG(L2)+dTP_kind_INT_offset])(L2);
 switch (L11) {
  case 1:
   ret_val = TRUE;
   return ret_val;
   break;
  case 2:
   ret_val = TRUE;
   return ret_val;
   break;
  case 3:
   ret_val = FALSE;
   return ret_val;
   break;
  case 4:
   ret_val = FALSE;
   return ret_val;
   break;
  case 5:
   ret_val = TRUE;
   return ret_val;
   break;
  case 6:
   ret_val = FALSE;
   return ret_val;
   break;
  case 7:
   ret_val = FALSE;
   return ret_val;
   break;
  default: ;
   FATAL("No applicable target in case statement");
 }
 FATAL("Last statement wasn't return");
}


BOOL CALL_TP_UNDERSCORE_is_su(CALL_TP_UNDERSCORE self, dTP t) {
 BOOL ret_val = ((BOOL) 0);
 dTP L1;
 if ((ATTR(self,tp1)==((dTP) NULL))) {
  ret_val = TRUE;
  return ret_val;
 }
 else {
  L1 = ATTR(self,tp1);
  if (L1==NULL) {
   FATAL("Dispatch on void in CALL_TP_UNDERSCORE::is_subtype($TP):BOOL");
  }
  ret_val = (*dTP_is_subtype_dTP_BOOL[TAG(L1)+dTP_is_subtype_dTP_BOOL_offset])(L1, t);
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


BOOL CALL_TP_VOID_is_subtype_(CALL_TP_VOID self, dTP t) {
 BOOL ret_val = ((BOOL) 0);
 ret_val = TRUE;
 return ret_val;
}


CALL_TP_ARRAY CALL_TP_ARRAY_create_CAL(CALL_TP_ARRAY self) {
 CALL_TP_ARRAY ret_val;
 CALL_TP_ARRAY L1;
 if ((CALL_TP_ARRAY_cache==((CALL_TP_ARRAY) NULL))) {
  L1 = ((CALL_TP_ARRAY) rt_alloc_atomic(sizeof(struct CALL_TP_ARRAY_struct), CALL_TP_ARRAY_tag));
  CALL_TP_ARRAY_cache_CALL(self, L1);
 }
 ret_val = CALL_TP_ARRAY_cache;
 return ret_val;
}


CALL_TP_CREATE CALL_TP_CREATE_create_CA(CALL_TP_CREATE self) {
 CALL_TP_CREATE ret_val;
 CALL_TP_CREATE L1;
 if ((CALL_TP_CREATE_cache==((CALL_TP_CREATE) NULL))) {
  L1 = ((CALL_TP_CREATE) rt_alloc_atomic(sizeof(struct CALL_TP_CREATE_struct), CALL_TP_CREATE_tag));
  CALL_TP_CREATE_cache_CAL(self, L1);
 }
 ret_val = CALL_TP_CREATE_cache;
 return ret_val;
}


CALL_TP_VOID CALL_TP_VOID_create_CALL(CALL_TP_VOID self) {
 CALL_TP_VOID ret_val;
 CALL_TP_VOID L1;
 if ((CALL_TP_VOID_cache==((CALL_TP_VOID) NULL))) {
  L1 = ((CALL_TP_VOID) rt_alloc_atomic(sizeof(struct CALL_TP_VOID_struct), CALL_TP_VOID_tag));
  CALL_TP_VOID_cache_CALL_(self, L1);
 }
 ret_val = CALL_TP_VOID_cache;
 return ret_val;
}


PROG CALL_SIG_prog_PROG(CALL_SIG self) {
 PROG ret_val;
 dTP L1;
 L1 = ATTR(self,tp1);
 if (L1==NULL) {
  FATAL("Dispatch on void in CALL_SIG::prog:PROG");
 }
 ret_val = (*dTP_prog_PROG[TAG(L1)+dTP_prog_PROG_offset])(L1);
 return ret_val;
}


SIG CALL_SIG_lookup_BOOL_SIG(CALL_SIG self, BOOL in_class) {
 SIG ret_val;
 dTP st;
 ARRAYdCALL_TP L11;
 dCALL_TP at;
 ARRAYdTP L21;
 dTP brat;
 ARRAYdCALL_TP L31;
 dCALL_TP at1;
 ARRAYdTP L41;
 dTP brat1;
 IMPL L5;
 IFC L6;
 PROG L7;
 extern STR Onlycallmaybeappliedtoab;
 BOOL L8;
 BOOL L9;
 PROG L10;
 extern STR Theboundroutine;
 STR L12;
 extern STR hasnoreturnvaluebutoneis;
 BOOL L13;
 BOOL L14;
 BOOL L15;
 PROG L16;
 extern STR Theboundroutine;
 STR L17;
 extern STR hasareturnvaluebutitisnt;
 INT L18;
 INT L19;
 PROG L20;
 extern STR Thecall;
 STR L22;
 extern STR hasthewrongnumberofargsf;
 STR L23;
 STR L24;
 extern STR name5;
 dCALL_TP L25;
 dTP L26;
 dCALL_TP L27;
 BOOL L28;
 PROG L29;
 extern STR Theargumenttype;
 dCALL_TP L30;
 STR L32;
 extern STR inthecall;
 STR L33;
 STR L34;
 extern STR doesntconformto;
 STR L35;
 dTP L36;
 STR L37;
 extern STR intheboundroutine;
 STR L38;
 STR L39;
 extern STR name5;
 PROG L40;
 extern STR Onlycallbmaybeappliedtoa;
 BOOL L42;
 BOOL L43;
 PROG L44;
 extern STR Thebounditer;
 STR L45;
 extern STR hasnoreturnvaluebutoneis;
 BOOL L46;
 BOOL L47;
 BOOL L48;
 PROG L49;
 extern STR Thebounditer;
 STR L50;
 extern STR hasareturnvaluebutitisnt;
 INT L51;
 INT L52;
 PROG L53;
 extern STR Thecall;
 STR L54;
 extern STR hasthewrongnumberofargsf;
 STR L55;
 STR L56;
 extern STR name5;
 dCALL_TP L57;
 dTP L58;
 dCALL_TP L59;
 BOOL L60;
 PROG L61;
 extern STR Theargumenttype;
 dCALL_TP L62;
 STR L63;
 extern STR inthecall;
 STR L64;
 STR L65;
 extern STR doesntconformto;
 STR L66;
 dTP L67;
 STR L68;
 extern STR intheboundroutine;
 STR L69;
 STR L70;
 extern STR name5;
 st = ATTR(self,tp1);
 if (st==NULL) {
  FATAL("Void object of typecase");
 } else
 switch (TAG(st)) {
  case TP_CLASS_tag:
   if (in_class) {
    L5 = IMPL_TBL_impl_of_dTP_IMP(ATTR(CALL_SIG_prog_PROG(self),impl_tbl), ATTR(self,tp1));
    ret_val = IMPL_sig_for_internal_ca(L5, self);
    return ret_val;
   }
   else {
    L6 = IFC_TBL_ifc_of_dTP_IFC(ATTR(CALL_SIG_prog_PROG(self),ifc_tbl), ATTR(self,tp1));
    ret_val = IFC_sig_for_call_CALL_SI(L6, self);
    return ret_val;
   } break;
  case TP_ROUT_tag:
   if (IDENT_is_neq_IDENT_BOOL(ATTR(self,name1), IDENT_BUILTIN_call_ident1)) {
    L7 = CALL_SIG_prog_PROG(self);
    PROG_err_STR(L7, ((STR) &Onlycallmaybeappliedtoab));
    ret_val = ((SIG) NULL);
    return ret_val;
   }
   L8 = ATTR(self,unknown_ret);
   if ((!(L8))) {
    if (ATTR(self,has_ret)) {
     L9 = (ATTR(((TP_ROUT) st),ret)==((dTP) NULL));
    } else {
     L9 = FALSE;
    }
    if (L9) {
     L10 = CALL_SIG_prog_PROG(self);
     L12 = STR_plus_dSTR_STR(((STR) &Theboundroutine), ((dSTR) TP_ROUT_str_STR(((TP_ROUT) st))));
     PROG_err_STR(L10, STR_plus_dSTR_STR(L12, ((dSTR) ((STR) &hasnoreturnvaluebutoneis))));
     ret_val = ((SIG) NULL);
     return ret_val;
    }
    else {
     L14 = ATTR(self,has_ret);
     if ((!(L14))) {
      L15 = (ATTR(((TP_ROUT) st),ret)==((dTP) NULL));
      L13 = (!(L15));
     } else {
      L13 = FALSE;
     }
     if (L13) {
      L16 = CALL_SIG_prog_PROG(self);
      L17 = STR_plus_dSTR_STR(((STR) &Theboundroutine), ((dSTR) TP_ROUT_str_STR(((TP_ROUT) st))));
      PROG_err_STR(L16, STR_plus_dSTR_STR(L17, ((dSTR) ((STR) &hasareturnvaluebutitisnt))));
      ret_val = ((SIG) NULL);
      return ret_val;
     }
    }
   }
   L18 = ARRAYdTP_size_INT(ATTR(((TP_ROUT) st),args));
   L19 = ARRAYdCALL_TP_size_INT(ATTR(self,args1));
   if ((L18!=L19)) {
    L20 = CALL_SIG_prog_PROG(self);
    L22 = STR_plus_dSTR_STR(((STR) &Thecall), ((dSTR) CALL_SIG_str_STR(self)));
    L23 = STR_plus_dSTR_STR(L22, ((dSTR) ((STR) &hasthewrongnumberofargsf)));
    L24 = STR_plus_dSTR_STR(L23, ((dSTR) TP_ROUT_str_STR(((TP_ROUT) st))));
    PROG_err_STR(L20, STR_plus_dSTR_STR(L24, ((dSTR) ((STR) &name5))));
    ret_val = ((SIG) NULL);
    return ret_val;
   }
   {
    struct ARRAYdCALL_TP_eltb_dCALL_frame_struct other1_0;
    ARRAYdCALL_TP_eltb_dCALL_frame 
    noname1 = &other1_0;
    struct ARRAYdTP_eltb_dTP_frame_struct other1_1;
    ARRAYdTP_eltb_dTP_frame 
    noname2 = &other1_1;
    noname1->state = 0;
    noname2->state = 0;
    while (1) {
     if (noname1->state == 0) {
      L11 = ATTR(self,args1);
      noname1->self = L11;
     }
     L25 = ARRAYdCALL_TP_eltb_dCALL(noname1);
     if (noname1->state == -1) {
      goto after_loop;
     }
     at = L25;
     if (noname2->state == 0) {
      L21 = ATTR(((TP_ROUT) st),args);
      noname2->self = L21;
     }
     L26 = ARRAYdTP_eltb_dTP(noname2);
     if (noname2->state == -1) {
      goto after_loop;
     }
     brat = L26;
     L27 = at;
     if (L27==NULL) {
      FATAL("Dispatch on void in CALL_SIG::lookup(BOOL):SIG");
     }
     L28 = (*dCALL_TP_is_subtype_dTP_[TAG(L27)+dCALL_TP_is_subtype_dTP__offset])(L27, brat);
     if ((!(L28))) {
      L29 = CALL_SIG_prog_PROG(self);
      L30 = at;
      if (L30==NULL) {
       FATAL("Dispatch on void in CALL_SIG::lookup(BOOL):SIG");
      }
      L32 = STR_plus_dSTR_STR(((STR) &Theargumenttype), ((dSTR) (*dCALL_TP_str_STR[TAG(L30)+dCALL_TP_str_STR_offset])(L30)));
      L33 = STR_plus_dSTR_STR(L32, ((dSTR) ((STR) &inthecall)));
      L34 = STR_plus_dSTR_STR(L33, ((dSTR) CALL_SIG_str_STR(self)));
      L35 = STR_plus_dSTR_STR(L34, ((dSTR) ((STR) &doesntconformto)));
      L36 = brat;
      if (L36==NULL) {
       FATAL("Dispatch on void in CALL_SIG::lookup(BOOL):SIG");
      }
      L37 = STR_plus_dSTR_STR(L35, ((dSTR) (*dTP_str_STR[TAG(L36)+dTP_str_STR_offset])(L36)));
      L38 = STR_plus_dSTR_STR(L37, ((dSTR) ((STR) &intheboundroutine)));
      L39 = STR_plus_dSTR_STR(L38, ((dSTR) TP_ROUT_str_STR(((TP_ROUT) st))));
      PROG_err_STR(L29, STR_plus_dSTR_STR(L39, ((dSTR) ((STR) &name5))));
      ret_val = ((SIG) NULL);
      return ret_val;
     }
    }
   }
   after_loop: ;
   ret_val = SIG_bound_routine_call_T(((SIG) NULL), ((TP_ROUT) st));
   return ret_val; break;
  case TP_ITER_tag:
   if (IDENT_is_neq_IDENT_BOOL(ATTR(self,name1), IDENT_BUILTIN_call_bang_1)) {
    L40 = CALL_SIG_prog_PROG(self);
    PROG_err_STR(L40, ((STR) &Onlycallbmaybeappliedtoa));
    ret_val = ((SIG) NULL);
    return ret_val;
   }
   L42 = ATTR(self,unknown_ret);
   if ((!(L42))) {
    if (ATTR(self,has_ret)) {
     L43 = (ATTR(((TP_ITER) st),ret)==((dTP) NULL));
    } else {
     L43 = FALSE;
    }
    if (L43) {
     L44 = CALL_SIG_prog_PROG(self);
     L45 = STR_plus_dSTR_STR(((STR) &Thebounditer), ((dSTR) TP_ITER_str_STR(((TP_ITER) st))));
     PROG_err_STR(L44, STR_plus_dSTR_STR(L45, ((dSTR) ((STR) &hasnoreturnvaluebutoneis))));
     ret_val = ((SIG) NULL);
     return ret_val;
    }
    else {
     L47 = ATTR(self,has_ret);
     if ((!(L47))) {
      L48 = (ATTR(((TP_ITER) st),ret)==((dTP) NULL));
      L46 = (!(L48));
     } else {
      L46 = FALSE;
     }
     if (L46) {
      L49 = CALL_SIG_prog_PROG(self);
      L50 = STR_plus_dSTR_STR(((STR) &Thebounditer), ((dSTR) TP_ITER_str_STR(((TP_ITER) st))));
      PROG_err_STR(L49, STR_plus_dSTR_STR(L50, ((dSTR) ((STR) &hasareturnvaluebutitisnt))));
      ret_val = ((SIG) NULL);
      return ret_val;
     }
    }
   }
   L51 = ARRAYdTP_size_INT(ATTR(((TP_ITER) st),args));
   L52 = ARRAYdCALL_TP_size_INT(ATTR(self,args1));
   if ((L51!=L52)) {
    L53 = CALL_SIG_prog_PROG(self);
    L54 = STR_plus_dSTR_STR(((STR) &Thecall), ((dSTR) CALL_SIG_str_STR(self)));
    L55 = STR_plus_dSTR_STR(L54, ((dSTR) ((STR) &hasthewrongnumberofargsf)));
    L56 = STR_plus_dSTR_STR(L55, ((dSTR) TP_ITER_str_STR(((TP_ITER) st))));
    PROG_err_STR(L53, STR_plus_dSTR_STR(L56, ((dSTR) ((STR) &name5))));
    ret_val = ((SIG) NULL);
    return ret_val;
   }
   {
    struct ARRAYdCALL_TP_eltb_dCALL_frame_struct other2_0;
    ARRAYdCALL_TP_eltb_dCALL_frame 
    noname3 = &other2_0;
    struct ARRAYdTP_eltb_dTP_frame_struct other2_1;
    ARRAYdTP_eltb_dTP_frame 
    noname4 = &other2_1;
    noname3->state = 0;
    noname4->state = 0;
    while (1) {
     if (noname3->state == 0) {
      L31 = ATTR(self,args1);
      noname3->self = L31;
     }
     L57 = ARRAYdCALL_TP_eltb_dCALL(noname3);
     if (noname3->state == -1) {
      goto after_loop1;
     }
     at1 = L57;
     if (noname4->state == 0) {
      L41 = ATTR(((TP_ITER) st),args);
      noname4->self = L41;
     }
     L58 = ARRAYdTP_eltb_dTP(noname4);
     if (noname4->state == -1) {
      goto after_loop1;
     }
     brat1 = L58;
     L59 = at1;
     if (L59==NULL) {
      FATAL("Dispatch on void in CALL_SIG::lookup(BOOL):SIG");
     }
     L60 = (*dCALL_TP_is_subtype_dTP_[TAG(L59)+dCALL_TP_is_subtype_dTP__offset])(L59, brat1);
     if ((!(L60))) {
      L61 = CALL_SIG_prog_PROG(self);
      L62 = at1;
      if (L62==NULL) {
       FATAL("Dispatch on void in CALL_SIG::lookup(BOOL):SIG");
      }
      L63 = STR_plus_dSTR_STR(((STR) &Theargumenttype), ((dSTR) (*dCALL_TP_str_STR[TAG(L62)+dCALL_TP_str_STR_offset])(L62)));
      L64 = STR_plus_dSTR_STR(L63, ((dSTR) ((STR) &inthecall)));
      L65 = STR_plus_dSTR_STR(L64, ((dSTR) CALL_SIG_str_STR(self)));
      L66 = STR_plus_dSTR_STR(L65, ((dSTR) ((STR) &doesntconformto)));
      L67 = brat1;
      if (L67==NULL) {
       FATAL("Dispatch on void in CALL_SIG::lookup(BOOL):SIG");
      }
      L68 = STR_plus_dSTR_STR(L66, ((dSTR) (*dTP_str_STR[TAG(L67)+dTP_str_STR_offset])(L67)));
      L69 = STR_plus_dSTR_STR(L68, ((dSTR) ((STR) &intheboundroutine)));
      L70 = STR_plus_dSTR_STR(L69, ((dSTR) TP_ITER_str_STR(((TP_ITER) st))));
      PROG_err_STR(L61, STR_plus_dSTR_STR(L70, ((dSTR) ((STR) &name5))));
      ret_val = ((SIG) NULL);
      return ret_val;
     }
    }
   }
   after_loop1: ;
   ret_val = SIG_bound_iter_call_TP_I(((SIG) NULL), ((TP_ITER) st));
   return ret_val; break;
  default: ;
   FATAL("No applicable type in typecase");
 }
 FATAL("Last statement wasn't return");
}


STR CALL_SIG_str_STR(CALL_SIG self) {
 STR ret_val;
 FSTR s;
 ARRAYdCALL_TP L11;
 STR L21;
 extern STR void1;
 FSTR L3;
 dTP L4;
 FSTR L5;
 extern STR name4;
 FSTR L6;
 BOOL L7;
 STR L8;
 extern STR name2;
 dCALL_TP L9;
 dCALL_TP L10;
 extern STR name78;
 extern STR S_1;
 if ((self==((CALL_SIG) NULL))) {
  ret_val = ((STR) &void1);
  return ret_val;
 }
 L3 = FSTR_create_FSTR(((FSTR) NULL));
 L4 = ATTR(self,tp1);
 if (L4==NULL) {
  FATAL("Dispatch on void in CALL_SIG::str:STR");
 }
 L5 = FSTR_plus_STR_FSTR(L3, (*dTP_str_STR[TAG(L4)+dTP_str_STR_offset])(L4));
 L6 = FSTR_plus_STR_FSTR(L5, ((STR) &name4));
 s = FSTR_plus_STR_FSTR(L6, ATTR(self,name1).str);
 L7 = (ATTR(self,args1)==((ARRAYdCALL_TP) NULL));
 if ((!(L7))) {
  s = FSTR_plus_CHAR_FSTR(s, '(');
  {
   struct ARRAYdCALL_TP_eltb_dCALL_frame_struct other1_0;
   ARRAYdCALL_TP_eltb_dCALL_frame 
   noname1 = &other1_0;
   struct STR_separateb_STR_STR_frame_struct other1_1;
   STR_separateb_STR_STR_frame 
   noname2 = &other1_1;
   noname1->state = 0;
   noname2->state = 0;
   while (1) {
    if (noname2->state == 0) {
     L21 = ((STR) &name2);
     noname2->self = L21;
    }
    if (noname1->state == 0) {
     L11 = ATTR(self,args1);
     noname1->self = L11;
    }
    L9 = ARRAYdCALL_TP_eltb_dCALL(noname1);
    if (noname1->state == -1) {
     goto after_loop;
    }
    L10 = L9;
    if (L10==NULL) {
     FATAL("Dispatch on void in CALL_SIG::str:STR");
    }
    noname2->arg1 = (*dCALL_TP_str_STR[TAG(L10)+dCALL_TP_str_STR_offset])(L10);
    L8 = STR_separateb_STR_STR(noname2);
    if (noname2->state == -1) {
     goto after_loop;
    }
    s = FSTR_plus_STR_FSTR(s, L8);
   }
  }
  after_loop: ;
  s = FSTR_plus_CHAR_FSTR(s, ')');
 }
 if (ATTR(self,unknown_ret)) {
  s = FSTR_plus_STR_FSTR(s, ((STR) &name78));
 }
 else {
  if (ATTR(self,has_ret)) {
   s = FSTR_plus_STR_FSTR(s, ((STR) &S_1));
  }
 }
 ret_val = FSTR_str_STR(s);
 return ret_val;
}


STR CALL_TP_ARRAY_str_STR(CALL_TP_ARRAY self) {
 STR ret_val;
 extern STR arrayexpression1;
 ret_val = ((STR) &arrayexpression1);
 return ret_val;
}


STR CALL_TP_CREATE_str_STR(CALL_TP_CREATE self) {
 STR ret_val;
 extern STR createexpression1;
 ret_val = ((STR) &createexpression1);
 return ret_val;
}


STR CALL_TP_UNDERSCORE_str_S(CALL_TP_UNDERSCORE self) {
 STR ret_val;
 extern STR underscoreexpression;
 extern STR underscoreexpression1;
 dTP L1;
 if ((ATTR(self,tp1)==((dTP) NULL))) {
  ret_val = ((STR) &underscoreexpression);
  return ret_val;
 }
 else {
  L1 = ATTR(self,tp1);
  if (L1==NULL) {
   FATAL("Dispatch on void in CALL_TP_UNDERSCORE::str:STR");
  }
  ret_val = STR_plus_dSTR_STR(((STR) &underscoreexpression1), ((dSTR) (*dTP_str_STR[TAG(L1)+dTP_str_STR_offset])(L1)));
  return ret_val;
 }
 FATAL("Last statement wasn't return");
}


STR CALL_TP_VOID_str_STR(CALL_TP_VOID self) {
 STR ret_val;
 extern STR voidexpression;
 ret_val = ((STR) &voidexpression);
 return ret_val;
}

/* C for type CALL_SIG */




CALL_SIG CALL_SIG_create_CALL_SIG(CALL_SIG self) {
 CALL_SIG ret_val;
 CALL_SIG L1;
 L1 = ((CALL_SIG) rt_alloc(sizeof(struct CALL_SIG_struct), CALL_SIG_tag));
 ret_val = L1;
 return ret_val;
}

/* C for type CALL_TP_ARRAY */




void CALL_TP_ARRAY_cache_CALL(CALL_TP_ARRAY self, CALL_TP_ARRAY cache1) {
 CALL_TP_ARRAY_cache = cache1;
}

/* C for type CALL_TP_CREATE */




void CALL_TP_CREATE_cache_CAL(CALL_TP_CREATE self, CALL_TP_CREATE cache1) {
 CALL_TP_CREATE_cache = cache1;
}

/* C for type CALL_TP_UNDERSCORE */




CALL_TP_UNDERSCORE CALL_TP_UNDERSCORE_creat(CALL_TP_UNDERSCORE self) {
 CALL_TP_UNDERSCORE ret_val;
 CALL_TP_UNDERSCORE L1;
 L1 = ((CALL_TP_UNDERSCORE) rt_alloc(sizeof(struct CALL_TP_UNDERSCORE_struct), CALL_TP_UNDERSCORE_tag));
 ret_val = L1;
 return ret_val;
}

/* C for type CALL_TP_VOID */




void CALL_TP_VOID_cache_CALL_(CALL_TP_VOID self, CALL_TP_VOID cache1) {
 CALL_TP_VOID_cache = cache1;
}
