#include "sather.h"

/* Layouts */

typedef struct CALL_TP_ARRAY_struct {/* layout for CALL_TP_ARRAY */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *CALL_TP_ARRAY;

typedef struct CALL_TP_CREATE_struct {/* layout for CALL_TP_CREATE */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *CALL_TP_CREATE;

typedef struct CALL_TP_VOID_struct {/* layout for CALL_TP_VOID */
 OB_HEADER header;
 CHAR field_so_not_empty;
 } *CALL_TP_VOID;

typedef struct IDENT_struct {/* layout for IDENT */
 STR str;
 } IDENT;
static IDENT IDENT_zero;

typedef struct IDENT_boxed_struct {
 OB_HEADER header;
 IDENT value_part;
 } *IDENT_boxed;

typedef struct MS_RANDOM_GEN_struct {/* layout for MS_RANDOM_GEN */
 OB_HEADER header;
 INT seed;
 } *MS_RANDOM_GEN;

typedef struct SFILE_ID_struct {/* layout for SFILE_ID */
 INT loc;
 } SFILE_ID;
static SFILE_ID SFILE_ID_zero;

typedef struct SFILE_ID_boxed_struct {
 OB_HEADER header;
 SFILE_ID value_part;
 } *SFILE_ID_boxed;

typedef struct TP_CLASS_struct {/* layout for TP_CLASS */
 OB_HEADER header;
 struct ARRAYdTP_struct *params;
 struct IDENT_struct name1;
 INT kind_cache;
 struct PROG_struct *prog1;
 STR sas_cache;
 BOOL atomic_cache;
 BOOL use_cached_atomic;
 } *TP_CLASS;

typedef struct TP_ROUT_struct {/* layout for TP_ROUT */
 OB_HEADER header;
 struct dTP_struct *ret;
 struct ARRAYdTP_struct *args;
 struct PROG_struct *prog1;
 STR sas_cache;
 } *TP_ROUT;

typedef struct TUPdTPdLAYOUT_struct {/* layout for TUP{$TP,$LAYOUT} */
 struct dLAYOUT_struct *t2;
 struct dTP_struct *t1;
 } TUPdTPdLAYOUT;
static TUPdTPdLAYOUT TUPdTPdLAYOUT_zero;

typedef struct TUPdTPdLAYOUT_boxed_struct {
 OB_HEADER header;
 TUPdTPdLAYOUT value_part;
 } *TUPdTPdLAYOUT_boxed;

typedef struct TUPAM_BND_CREATE_EXPRBOU_struct {/* layout for TUP{AM_BND_CREATE_EXPR,BOUND_OBJECT_LAYOUT} */
 struct AM_BND_CREATE_EXPR_struct *t1;
 struct BOUND_OBJECT_LAYOUT_struct *t2;
 } TUPAM_BND_CREATE_EXPRBOU;
static TUPAM_BND_CREATE_EXPRBOU TUPAM_BND_CREATE_EXPRBOU_zero;

typedef struct TUPAM_BND_CREATE_EXPRBOU_boxed_struct {
 OB_HEADER header;
 TUPAM_BND_CREATE_EXPRBOU value_part;
 } *TUPAM_BND_CREATE_EXPRBOU_boxed;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_struct {/* layout for TUP{AM_ROUT_DEF,FRAME_LAYOUT} */
 struct AM_ROUT_DEF_struct *t1;
 struct FRAME_LAYOUT_struct *t2;
 } TUPAM_ROUT_DEFFRAME_LAYO;
static TUPAM_ROUT_DEFFRAME_LAYO TUPAM_ROUT_DEFFRAME_LAYO_zero;

typedef struct TUPAM_ROUT_DEFFRAME_LAYO_boxed_struct {
 OB_HEADER header;
 TUPAM_ROUT_DEFFRAME_LAYO value_part;
 } *TUPAM_ROUT_DEFFRAME_LAYO_boxed;

typedef struct TUPSIGABSTRACT_FRAME_LAY_struct {/* layout for TUP{SIG,ABSTRACT_FRAME_LAYOUT} */
 struct ABSTRACT_FRAME_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGABSTRACT_FRAME_LAY;
static TUPSIGABSTRACT_FRAME_LAY TUPSIGABSTRACT_FRAME_LAY_zero;

typedef struct TUPSIGABSTRACT_FRAME_LAY_boxed_struct {
 OB_HEADER header;
 TUPSIGABSTRACT_FRAME_LAY value_part;
 } *TUPSIGABSTRACT_FRAME_LAY_boxed;

typedef struct TUPSIGAM_ROUT_DEF_struct {/* layout for TUP{SIG,AM_ROUT_DEF} */
 struct AM_ROUT_DEF_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGAM_ROUT_DEF;
static TUPSIGAM_ROUT_DEF TUPSIGAM_ROUT_DEF_zero;

typedef struct TUPSIGAM_ROUT_DEF_boxed_struct {
 OB_HEADER header;
 TUPSIGAM_ROUT_DEF value_part;
 } *TUPSIGAM_ROUT_DEF_boxed;

typedef struct TUPSIGARG_LAYOUT_struct {/* layout for TUP{SIG,ARG_LAYOUT} */
 struct ARG_LAYOUT_struct *t2;
 struct SIG_struct *t1;
 } TUPSIGARG_LAYOUT;
static TUPSIGARG_LAYOUT TUPSIGARG_LAYOUT_zero;

typedef struct TUPSIGARG_LAYOUT_boxed_struct {
 OB_HEADER header;
 TUPSIGARG_LAYOUT value_part;
 } *TUPSIGARG_LAYOUT_boxed;

typedef struct TUPSTRSIG_struct {/* layout for TUP{STR,SIG} */
 struct SIG_struct *t2;
 STR t1;
 } TUPSTRSIG;
static TUPSTRSIG TUPSTRSIG_zero;

typedef struct TUPSTRSIG_boxed_struct {
 OB_HEADER header;
 TUPSTRSIG value_part;
 } *TUPSTRSIG_boxed;

typedef struct TUPSTRSTR_struct {/* layout for TUP{STR,STR} */
 STR t1;
 STR t2;
 } TUPSTRSTR;
static TUPSTRSTR TUPSTRSTR_zero;

typedef struct TUPSTRSTR_boxed_struct {
 OB_HEADER header;
 TUPSTRSTR value_part;
 } *TUPSTRSTR_boxed;

typedef struct CGEN_struct {/* layout for CGEN */
 OB_HEADER header;
 struct AM_ROUT_DEF_struct *current_am_rout_def;
 struct CODE_FILE_struct *code_c;
 struct CODE_FILE_struct *dispatch_c;
 struct CODE_FILE_struct *globals_c;
 struct CODE_FILE_struct *makefile;
 struct CODE_FILE_struct *sather_h;
 struct CODE_FILE_struct *strings_c;
 struct CODE_FILE_struct *system_c;
 struct CODE_FILE_struct *tags_h;
 struct CODE_FILE_struct *unbox_c;
 struct CS_OPTIONS_struct *options1;
 struct FLISTAM_BND_CREATE_EXPR_struct *bnd_rout_creates;
 struct FLISTAM_ROUT_DEF_struct *abstract_iters;
 struct FLISTAM_ROUT_DEF_struct *abstract_routs;
 struct FLISTSTR_struct *archive_files;
 struct FLISTSTR_struct *c_flags;
 struct FMAPdTPCODE_FILE_struct *code_files;
 struct FMAPdTPINT_struct *tags;
 struct FMAPAM_ROUT_DEFFLISTAM_I_struct *nested_its;
 struct FMAPSIGAM_ROUT_DEF_struct *not_emitted;
 struct FMAPSIGSTR_struct *emitted_dispatch_wrapper;
 struct FMAPSTRFSETSTR_struct *externals;
 struct FMAPSTRITER_INLINE_struct *built_in_iters;
 struct FMAPSTRSTR_struct *built_in_routines;
 struct FMAPSTRSTR_struct *special_externs;
 struct FMAPSTRSTR_struct *string_constants;
 struct FSETdTP_struct *built_in_classes;
 struct FSETdTP_struct *needs_tag;
 struct FSETAM_ROUT_DEF_struct *emitted_leftovers;
 struct FSETAM_ROUT_DEF_struct *leftovers;
 struct FSETSIG_struct *arg_frames;
 struct FSETSTR_struct *c_files;
 struct FSETSTR_struct *force_routines;
 struct FSETSTR_struct *object_files;
 struct FSTR_struct *routine_code;
 struct GENERATE_AM_struct *gen;
 INT abstract_calls;
 INT concrete_calls;
 INT current_loop_ex_nesting;
 INT ex_nesting;
 INT indent;
 INT inlined_iter_count;
 INT inlined_pointer_ob_eq_ca;
 INT inlined_value_ob_eq_call;
 INT last_lineno;
 INT routine_count;
 INT state_counter;
 INT str_count;
 INT threshold;
 struct MANGLE_struct *mangler;
 struct PROG_struct *prog1;
 struct SIG_struct *current_sig;
 struct SIG_struct *main_sig;
 STR c_compile1;
 STR c_compile2;
 STR c_debug;
 STR c_exec;
 STR c_lib;
 STR c_obj;
 STR c_opt;
 STR c_prolix;
 STR c_sep;
 STR code_dir;
 STR comp_home;
 STR current_function_str;
 STR current_loop;
 STR executable1;
 STR make_command;
 STR make_silent;
 STR psather_opt1;
 STR psather_opt2;
 BOOL chk_arith;
 BOOL chk_assert;
 BOOL chk_bounds;
 BOOL chk_invariant;
 BOOL chk_post;
 BOOL chk_pre;
 BOOL chk_return;
 BOOL chk_void;
 BOOL chk_when;
 BOOL debug1;
 BOOL deterministic1;
 BOOL force_all;
 BOOL gen_c;
 BOOL null_segfaults;
 BOOL only_C;
 BOOL only_check;
 BOOL optimize;
 BOOL pretty;
 BOOL saw_outer_return;
 } *CGEN;

typedef struct FLISTdLAYOUT_struct {/* layout for FLIST{$LAYOUT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct dLAYOUT_struct *arr_part[1];
 } *FLISTdLAYOUT;

typedef struct FLISTCODE_FILE_struct {/* layout for FLIST{CODE_FILE} */
 OB_HEADER header;
 INT loc;
 INT asize;
 struct CODE_FILE_struct *arr_part[1];
 } *FLISTCODE_FILE;

typedef struct FLISTINT_struct {/* layout for FLIST{INT} */
 OB_HEADER header;
 INT loc;
 INT asize;
 INT arr_part[1];
 } *FLISTINT;

typedef struct FLISTSTR_struct {/* layout for FLIST{STR} */
 OB_HEADER header;
 INT loc;
 INT asize;
 STR arr_part[1];
 } *FLISTSTR;

typedef struct FMAPdTPdLAYOUT_struct {/* layout for FMAP{$TP,$LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPdTPdLAYOUT_struct arr_part[1];
 } *FMAPdTPdLAYOUT;

typedef struct FMAPAM_BND_CREATE_EXPRBO_struct {/* layout for FMAP{AM_BND_CREATE_EXPR,BOUND_OBJECT_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_BND_CREATE_EXPRBOU_struct arr_part[1];
 } *FMAPAM_BND_CREATE_EXPRBO;

typedef struct FMAPAM_ROUT_DEFFRAME_LAY_struct {/* layout for FMAP{AM_ROUT_DEF,FRAME_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPAM_ROUT_DEFFRAME_LAYO_struct arr_part[1];
 } *FMAPAM_ROUT_DEFFRAME_LAY;

typedef struct FMAPSIGABSTRACT_FRAME_LA_struct {/* layout for FMAP{SIG,ABSTRACT_FRAME_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGABSTRACT_FRAME_LAY_struct arr_part[1];
 } *FMAPSIGABSTRACT_FRAME_LA;

typedef struct FMAPSIGAM_ROUT_DEF_struct {/* layout for FMAP{SIG,AM_ROUT_DEF} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGAM_ROUT_DEF_struct arr_part[1];
 } *FMAPSIGAM_ROUT_DEF;

typedef struct FMAPSIGARG_LAYOUT_struct {/* layout for FMAP{SIG,ARG_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSIGARG_LAYOUT_struct arr_part[1];
 } *FMAPSIGARG_LAYOUT;

typedef struct FMAPSTRSIG_struct {/* layout for FMAP{STR,SIG} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRSIG_struct arr_part[1];
 } *FMAPSTRSIG;

typedef struct FMAPSTRSTR_struct {/* layout for FMAP{STR,STR} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct TUPSTRSTR_struct arr_part[1];
 } *FMAPSTRSTR;

typedef struct FSETABSTRACT_LAYOUT_struct {/* layout for FSET{ABSTRACT_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct ABSTRACT_LAYOUT_struct *arr_part[1];
 } *FSETABSTRACT_LAYOUT;

typedef struct FSETBOUND_TYPE_LAYOUT_struct {/* layout for FSET{BOUND_TYPE_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct BOUND_TYPE_LAYOUT_struct *arr_part[1];
 } *FSETBOUND_TYPE_LAYOUT;

typedef struct FSETBUILTIN_LAYOUT_struct {/* layout for FSET{BUILTIN_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct BUILTIN_LAYOUT_struct *arr_part[1];
 } *FSETBUILTIN_LAYOUT;

typedef struct FSETCLASS_LAYOUT_struct {/* layout for FSET{CLASS_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct CLASS_LAYOUT_struct *arr_part[1];
 } *FSETCLASS_LAYOUT;

typedef struct FSETEXTERNAL_LAYOUT_struct {/* layout for FSET{EXTERNAL_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct EXTERNAL_LAYOUT_struct *arr_part[1];
 } *FSETEXTERNAL_LAYOUT;

typedef struct FSETVALUE_CLASS_LAYOUT_struct {/* layout for FSET{VALUE_CLASS_LAYOUT} */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct VALUE_CLASS_LAYOUT_struct *arr_part[1];
 } *FSETVALUE_CLASS_LAYOUT;

typedef struct FSTR_struct {/* layout for FSTR */
 OB_HEADER header;
 INT loc;
 INT asize;
 CHAR arr_part[1];
 } *FSTR;

typedef struct IDENT_TBL_struct {/* layout for IDENT_TBL */
 OB_HEADER header;
 INT hsize;
 INT asize;
 struct IDENT_struct arr_part[1];
 } *IDENT_TBL;

typedef struct PROG_struct {/* layout for PROG */
 OB_HEADER header;
 struct dBACK_END_struct *back_end;
 struct dBUILD_TYPE_GRAPH_struct *build_type_graph;
 struct dCHECK_AM_struct *check_am;
 struct dCHECK_IFC_CONFORMANCE_struct *check_ifc_conformance;
 struct dFIND_TYPES_struct *find_types;
 struct dGENERATE_AM_struct *generate_am;
 struct dGET_MAIN_SIG_struct *get_main_sig;
 struct dGET_OPTIONS_struct *get_options;
 struct dINLINE_struct *inliner;
 struct dOPTIMIZE_struct *optimizer;
 struct dPARSE_struct *parse;
 struct FLISTSFILE_ID_struct *err_list;
 struct FSETdTP_struct *tp_done;
 struct FSETSTR_struct *sather_files;
 struct IFC_TBL_struct *ifc_tbl;
 struct IMPL_TBL_struct *impl_tbl;
 struct IMPORT_EXPORT_TBL_struct *import_export_tbl;
 struct PROG_AS_TBL_struct *as_tbl;
 struct SFILE_ID_struct eloc;
 STR home;
 STR main_class;
 struct TP_GRAPH_struct *tp_graph;
 struct TP_GRAPH_ABS_DES_struct *tp_graph_abs_des;
 struct TP_TBL_struct *tp_tbl;
 BOOL all_reached;
 BOOL err_seen;
 BOOL generate_checked_code;
 BOOL prolix;
 BOOL psather;
 BOOL show_am;
 BOOL show_am_check;
 BOOL show_as_insert;
 BOOL show_checked_sig;
 BOOL show_generated_sig;
 BOOL show_graphs;
 BOOL show_ifc;
 BOOL show_ifc_abs_create;
 BOOL show_impl_create;
 BOOL show_include;
 BOOL show_main;
 BOOL show_parse_file;
 BOOL show_tr;
 BOOL show_types;
 BOOL verbose;
 } *PROG;

#include "tags.h"

/* Globals */


/* Function declarations */


/* Bound rout stubs decls */


/* Unbox decls */


/* External calls */


/* Code */


IDENT_TBL IDENT_ident_tbl = ((IDENT_TBL) NULL);
const INT IDENT_TBL_load_ratio = 4;
FSTR INT_buf = ((FSTR) NULL);
const INT INT_asize = 32;
const INT INTI_log2B = 15;
INT INTI_B;
FLISTSTR SFILE_ID_files = ((FLISTSTR) NULL);
FLISTINT SFILE_ID_lines = ((FLISTINT) NULL);
const INT SFILE_ID_B = 1024;
FSTR FLT_fbuf = ((FSTR) NULL);
FSTR FLTD_fdbuf = ((FSTR) NULL);
FSTR INTI_buf = ((FSTR) NULL);
const INT INTI_log10D = 4;
INT INTI_D;
IDENT IDENT_BUILTIN_dollar_OB_1;
IDENT IDENT_BUILTIN_ARR_ident;
IDENT IDENT_BUILTIN_INT_ident;
IDENT IDENT_BUILTIN_INTI_ident1;
IDENT IDENT_BUILTIN_FLT_ident;
IDENT IDENT_BUILTIN_FLTD_ident1;
IDENT IDENT_BUILTIN_FLTDX_iden1;
IDENT IDENT_BUILTIN_FLTX_ident1;
IDENT IDENT_BUILTIN_plus_ident1;
IDENT IDENT_BUILTIN_minus_iden1;
IDENT IDENT_BUILTIN_times_iden1;
IDENT IDENT_BUILTIN_div_ident;
IDENT IDENT_BUILTIN_pow_ident;
IDENT IDENT_BUILTIN_mod_ident;
IDENT IDENT_BUILTIN_is_lt_iden1;
IDENT IDENT_BUILTIN_is_leq_ide1;
IDENT IDENT_BUILTIN_is_gt_iden1;
IDENT IDENT_BUILTIN_is_geq_ide1;
IDENT IDENT_BUILTIN_negate_ide1;
IDENT IDENT_BUILTIN_not_ident;
IDENT IDENT_BUILTIN_AVAL_ident1;
IDENT IDENT_BUILTIN_AREF_ident1;
IDENT IDENT_BUILTIN_aget_ident1;
IDENT IDENT_BUILTIN_aset_ident1;
IDENT IDENT_BUILTIN_call_ident1;
IDENT IDENT_BUILTIN_call_bang_1;
IDENT IDENT_BUILTIN_create_ide1;
IDENT IDENT_BUILTIN_ARRAY_iden1;
IDENT IDENT_BUILTIN_ret_ident;
IDENT IDENT_BUILTIN_self_ident1;
IDENT IDENT_BUILTIN_invariant_1;
IDENT IDENT_BUILTIN_asize_iden1;
IDENT IDENT_BUILTIN_main_ident1;
IDENT IDENT_BUILTIN_is_eq_iden1;
IDENT IDENT_BUILTIN_is_neq_ide1;
IDENT IDENT_BUILTIN_GATE_ident1;
IDENT IDENT_BUILTIN_ob_eq_iden1;
IDENT IDENT_BUILTIN_bang_ident1;
IDENT IDENT_BUILTIN_SYS_ident;
const INT TP_KIND_missing_tp = 0;
const INT TP_CLASS_TBL_load_ratio = 4;
FSTR STR_buf = ((FSTR) NULL);
TP_CLASS TP_BUILTIN_dollar_ob = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_bool = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_char = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_int = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_inti = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_flt = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_fltd = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_fltx = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_fltdx = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_flti = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_str = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_sys = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_ext_ob = ((TP_CLASS) NULL);
const INT TP_ROUT_TBL_load_ratio = 4;
TP_ROUT TP_BUILTIN_rout = ((TP_ROUT) NULL);
TP_CLASS TP_BUILTIN_arr_of_str = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_gate = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_mutex = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_dollar_lock = ((TP_CLASS) NULL);
TP_CLASS TP_BUILTIN_cleared_ex = ((TP_CLASS) NULL);
const INT INLINE_ROUT_TBL_load_rat = 4;
const INT INLINE_ITER_TBL_load_rat = 4;
FMAPSTRSIG SIG_sigs = ((FMAPSTRSIG) NULL);
const INT FMAPSTRSIG_load_ratio = 4;
INT INLINE_INT_FOLD_routines1 = ((INT) 0);
const INT INLINE_default_rout_thre = 16;
const INT INLINE_default_iter_thre = 16;
PROG LAYOUT_TBL_prog = ((PROG) NULL);
CGEN LAYOUT_TBL_cgen = ((CGEN) NULL);
const INT FSETSTR_load_ratio = 4;
const INT FMAPSTRSTR_load_ratio = 4;
const INT FMAPSTRFSETSTR_load_rati = 4;
const INT STR_CURSOR_No_Error = 0;
const INT STR_CURSOR_Past_EOBuf = 2;
const INT STR_CURSOR_Int_No_Bits = 32;
const INT STR_CURSOR_Too_Many_Digi = 4;
const INT STR_CURSOR_Bad_Digit = 1;
const INT STR_CURSOR_Past_BOBuf = 3;
const INT STR_CURSOR_Max_Int_Digit = 9;
const INT FSETTUPIDENTIDENT_load_r = 4;
FLTD TIME_time_at_start = ((FLTD) 0);
FSTR SFILE_ID_source = ((FSTR) NULL);
const INT SFILE_ID_sentinel = 2147483647;
INT SFILE_ID_pos = ((INT) 0);
INT SFILE_ID_column = ((INT) 0);
BOOL SFILE_ID_newline = ((BOOL) 0);
INT SFILE_ID_line = 0;
INT SFILE_ID_line_pos = ((INT) 0);
const CHAR SFILE_ID_eof_char = '\0';
const INT SCANNER_null_tok = 1;
const INT SCANNER_eof_tok = 0;
const INT SCANNER_ident_tok = 2;
const INT SCANNER_attr_tok = 6;
const INT SCANNER_and_tok = 4;
const INT SCANNER_assert_tok = 5;
const INT SCANNER_any_tok = 98;
const INT SCANNER_break_tok = 7;
const INT SCANNER_const_tok = 10;
const INT SCANNER_class_tok = 9;
const INT SCANNER_case_tok = 8;
const INT SCANNER_cohort_tok = 100;
const INT SCANNER_cluster_tok = 101;
const INT SCANNER_cluster_bang_tok = 99;
const INT SCANNER_do_tok = 95;
const INT SCANNER_end_tok = 13;
const INT SCANNER_elsif_tok = 12;
const INT SCANNER_else_tok = 11;
const INT SCANNER_exception_tok = 14;
const INT SCANNER_external_tok = 15;
const INT SCANNER_false_tok = 16;
const INT SCANNER_far_tok = 93;
const INT SCANNER_fork_tok = 84;
const INT SCANNER_here_tok = 90;
const INT SCANNER_is_tok = 20;
const INT SCANNER_if_tok = 17;
const INT SCANNER_include_tok = 18;
const INT SCANNER_initial_tok = 19;
const INT SCANNER_ITER_tok = 21;
const INT SCANNER_loop_tok = 22;
const INT SCANNER_lock_tok = 85;
const INT SCANNER_new_tok = 23;
const INT SCANNER_near_tok = 92;
const INT SCANNER_or_tok = 24;
const INT SCANNER_pre_tok = 26;
const INT SCANNER_private_tok = 27;
const INT SCANNER_post_tok = 25;
const INT SCANNER_protect_tok = 28;
const INT SCANNER_par_tok = 96;
const INT SCANNER_parloop_tok = 97;
const INT SCANNER_quit_tok = 29;
const INT SCANNER_return_tok = 33;
const INT SCANNER_raise_tok = 30;
const INT SCANNER_readonly_tok = 31;
const INT SCANNER_result_tok = 32;
const INT SCANNER_ROUT_tok = 34;
const INT SCANNER_self_tok = 36;
const INT SCANNER_shared_tok = 37;
const INT SCANNER_spread_tok = 94;
const INT SCANNER_SAME_tok = 35;
const INT SCANNER_then_tok = 38;
const INT SCANNER_true_tok = 39;
const INT SCANNER_typecase_tok = 41;
const INT SCANNER_type_tok = 40;
const INT SCANNER_try_tok = 87;
const INT SCANNER_until_tok = 42;
const INT SCANNER_unlock_tok = 86;
const INT SCANNER_void_tok = 44;
const INT SCANNER_value_tok = 43;
const INT SCANNER_when_tok = 45;
const INT SCANNER_while_tok = 46;
const INT SCANNER_where_tok = 91;
const INT SCANNER_with_tok = 88;
const INT SCANNER_yield_tok = 47;
const INT SCANNER_lparen_tok = 52;
const INT SCANNER_rparen_tok = 53;
const INT SCANNER_lbracket_tok = 54;
const INT SCANNER_rbracket_tok = 55;
const INT SCANNER_lbrace_tok = 56;
const INT SCANNER_rbrace_tok = 57;
const INT SCANNER_comma_tok = 58;
const INT SCANNER_dot_tok = 59;
const INT SCANNER_semi_tok = 60;
const INT SCANNER_type_name_tok = 3;
const INT SCANNER_plus_tok = 63;
const INT SCANNER_transform_tok = 80;
const INT SCANNER_minus_tok = 64;
const INT SCANNER_times_tok = 65;
const INT SCANNER_sharp_tok = 69;
const INT SCANNER_pow_tok = 72;
const INT SCANNER_mod_tok = 73;
const INT SCANNER_vbar_tok = 74;
const INT SCANNER_bang_tok = 70;
const INT SCANNER_iter_bang_tok = 71;
const INT SCANNER_under_tok = 62;
const INT SCANNER_is_eq_tok = 81;
const INT SCANNER_colon_tok = 61;
const INT SCANNER_dcolon_tok = 79;
const INT SCANNER_assign_tok = 78;
const INT SCANNER_attach_tok = 83;
const INT SCANNER_is_neq_tok = 75;
const INT SCANNER_quotient_tok = 66;
const INT SCANNER_is_leq_tok = 76;
const INT SCANNER_is_lt_tok = 67;
const INT SCANNER_is_geq_tok = 77;
const INT SCANNER_is_gt_tok = 68;
const INT SCANNER_not_tok = 82;
const INT SCANNER_lchar_tok = 51;
const INT SCANNER_lstr_tok = 50;
const INT SCANNER_lint_tok = 48;
const INT SCANNER_lflt_tok = 49;
const INT AS_FLT_LIT_EXPR_flt = 0;
const INT AS_FLT_LIT_EXPR_flti = 4;
const INT AS_FLT_LIT_EXPR_fltdx = 3;
const INT AS_FLT_LIT_EXPR_fltd = 1;
const INT AS_FLT_LIT_EXPR_fltx = 2;
const INT SCANNER_at_tok = 89;
const INT PARSER_type_tok = 40;
const INT PARSER_spread_tok = 94;
const INT PARSER_value_tok = 43;
const INT PARSER_external_tok = 15;
const INT PARSER_class_tok = 9;
const INT AS_CLASS_DEF_abs = 3;
const INT TOKEN_eof_tok = 0;
const INT TOKEN_null_tok = 1;
const INT TOKEN_ident_tok = 2;
const INT TOKEN_type_name_tok = 3;
const INT TOKEN_and_tok = 4;
const INT TOKEN_assert_tok = 5;
const INT TOKEN_attr_tok = 6;
const INT TOKEN_break_tok = 7;
const INT TOKEN_case_tok = 8;
const INT TOKEN_class_tok = 9;
const INT TOKEN_const_tok = 10;
const INT TOKEN_else_tok = 11;
const INT TOKEN_elsif_tok = 12;
const INT TOKEN_end_tok = 13;
const INT TOKEN_exception_tok = 14;
const INT TOKEN_external_tok = 15;
const INT TOKEN_false_tok = 16;
const INT TOKEN_if_tok = 17;
const INT TOKEN_include_tok = 18;
const INT TOKEN_initial_tok = 19;
const INT TOKEN_is_tok = 20;
const INT TOKEN_ITER_tok = 21;
const INT TOKEN_loop_tok = 22;
const INT TOKEN_new_tok = 23;
const INT TOKEN_or_tok = 24;
const INT TOKEN_post_tok = 25;
const INT TOKEN_pre_tok = 26;
const INT TOKEN_private_tok = 27;
const INT TOKEN_protect_tok = 28;
const INT TOKEN_quit_tok = 29;
const INT TOKEN_raise_tok = 30;
const INT TOKEN_readonly_tok = 31;
const INT TOKEN_return_tok = 33;
const INT TOKEN_ROUT_tok = 34;
const INT TOKEN_SAME_tok = 35;
const INT TOKEN_self_tok = 36;
const INT TOKEN_shared_tok = 37;
const INT TOKEN_then_tok = 38;
const INT TOKEN_true_tok = 39;
const INT TOKEN_type_tok = 40;
const INT TOKEN_typecase_tok = 41;
const INT TOKEN_value_tok = 43;
const INT TOKEN_void_tok = 44;
const INT TOKEN_when_tok = 45;
const INT TOKEN_while_tok = 46;
const INT TOKEN_until_tok = 42;
const INT TOKEN_yield_tok = 47;
const INT TOKEN_lint_tok = 48;
const INT TOKEN_lflt_tok = 49;
const INT TOKEN_lstr_tok = 50;
const INT TOKEN_lchar_tok = 51;
const INT TOKEN_lparen_tok = 52;
const INT TOKEN_rparen_tok = 53;
const INT TOKEN_lbracket_tok = 54;
const INT TOKEN_rbracket_tok = 55;
const INT TOKEN_lbrace_tok = 56;
const INT TOKEN_rbrace_tok = 57;
const INT TOKEN_comma_tok = 58;
const INT TOKEN_dot_tok = 59;
const INT TOKEN_semi_tok = 60;
const INT TOKEN_colon_tok = 61;
const INT TOKEN_under_tok = 62;
const INT TOKEN_plus_tok = 63;
const INT TOKEN_minus_tok = 64;
const INT TOKEN_times_tok = 65;
const INT TOKEN_quotient_tok = 66;
const INT TOKEN_is_lt_tok = 67;
const INT TOKEN_is_gt_tok = 68;
const INT TOKEN_sharp_tok = 69;
const INT TOKEN_bang_tok = 70;
const INT TOKEN_iter_bang_tok = 71;
const INT TOKEN_pow_tok = 72;
const INT TOKEN_mod_tok = 73;
const INT TOKEN_vbar_tok = 74;
const INT TOKEN_is_neq_tok = 75;
const INT TOKEN_is_leq_tok = 76;
const INT TOKEN_is_geq_tok = 77;
const INT TOKEN_assign_tok = 78;
const INT TOKEN_transform_tok = 80;
const INT TOKEN_is_eq_tok = 81;
const INT TOKEN_not_tok = 82;
const INT TOKEN_dcolon_tok = 79;
const INT TOKEN_attach_tok = 83;
const INT TOKEN_fork_tok = 84;
const INT TOKEN_lock_tok = 85;
const INT TOKEN_unlock_tok = 86;
const INT TOKEN_try_tok = 87;
const INT TOKEN_with_tok = 88;
const INT TOKEN_at_tok = 89;
const INT TOKEN_here_tok = 90;
const INT TOKEN_where_tok = 91;
const INT TOKEN_near_tok = 92;
const INT TOKEN_far_tok = 93;
const INT TOKEN_spread_tok = 94;
const INT TOKEN_do_tok = 95;
const INT TOKEN_par_tok = 96;
const INT TOKEN_parloop_tok = 97;
const INT TOKEN_any_tok = 98;
const INT TOKEN_cluster_tok = 101;
const INT TOKEN_cluster_bang_tok = 99;
const INT TOKEN_cohort_tok = 100;
const INT PARSER_type_name_tok = 3;
const INT PARSER_ident_tok = 2;
const INT PARSER_lbrace_tok = 56;
const INT PARSER_is_lt_tok = 67;
const INT PARSER_SAME_tok = 35;
const INT AS_TYPE_SPEC_same = 3;
const INT AS_TYPE_SPEC_ord = 0;
const INT PARSER_comma_tok = 58;
const INT PARSER_rbrace_tok = 57;
const INT PARSER_ROUT_tok = 34;
const INT AS_TYPE_SPEC_rt = 1;
const INT PARSER_ITER_tok = 21;
const INT AS_TYPE_SPEC_it = 2;
const INT PARSER_bang_tok = 70;
const INT PARSER_iter_bang_tok = 71;
const INT PARSER_colon_tok = 61;
const INT PARSER_is_gt_tok = 68;
const INT PARSER_is_tok = 20;
const INT PARSER_lparen_tok = 52;
const INT PARSER_rparen_tok = 53;
const INT PARSER_semi_tok = 60;
const INT PARSER_end_tok = 13;
const INT PARSER_eof_tok = 0;
const INT AS_CLASS_DEF_spr = 5;
const INT AS_CLASS_DEF_val = 1;
const INT AS_CLASS_DEF_ext = 4;
const INT AS_CLASS_DEF_ref = 2;
const INT PARSER_private_tok = 27;
const INT PARSER_readonly_tok = 31;
const INT PARSER_const_tok = 10;
const INT PARSER_shared_tok = 37;
const INT PARSER_attr_tok = 6;
const INT PARSER_include_tok = 18;
const INT PARSER_null_tok = 1;
const INT PARSER_transform_tok = 80;
const INT PARSER_assign_tok = 78;
const INT PARSER_minus_tok = 64;
const INT PARSER_not_tok = 82;
const INT PARSER_self_tok = 36;
const INT PARSER_dcolon_tok = 79;
const INT PARSER_void_tok = 44;
const INT PARSER_new_tok = 23;
const INT PARSER_sharp_tok = 69;
const INT PARSER_under_tok = 62;
const INT PARSER_dot_tok = 59;
const INT PARSER_vbar_tok = 74;
const INT PARSER_exception_tok = 14;
const INT PARSER_initial_tok = 19;
const INT PARSER_result_tok = 32;
const INT PARSER_while_tok = 46;
const INT PARSER_until_tok = 42;
const INT PARSER_break_tok = 7;
const INT PARSER_true_tok = 39;
const INT PARSER_false_tok = 16;
const INT PARSER_lchar_tok = 51;
const INT PARSER_lstr_tok = 50;
const INT PARSER_lint_tok = 48;
const INT PARSER_lflt_tok = 49;
const INT PARSER_lbracket_tok = 54;
const INT PARSER_rbracket_tok = 55;
const INT PARSER_here_tok = 90;
const INT PARSER_cluster_tok = 101;
const INT PARSER_cluster_bang_tok = 99;
const INT PARSER_cohort_tok = 100;
const INT PARSER_where_tok = 91;
const INT PARSER_near_tok = 92;
const INT PARSER_far_tok = 93;
const INT PARSER_pow_tok = 72;
const INT PARSER_times_tok = 65;
const INT PARSER_quotient_tok = 66;
const INT PARSER_mod_tok = 73;
const INT PARSER_plus_tok = 63;
const INT PARSER_is_eq_tok = 81;
const INT PARSER_is_neq_tok = 75;
const INT PARSER_is_leq_tok = 76;
const INT PARSER_is_geq_tok = 77;
const INT PARSER_and_tok = 4;
const INT PARSER_or_tok = 24;
const INT PARSER_at_tok = 89;
const INT PARSER_any_tok = 98;
const INT PARSER_pre_tok = 26;
const INT PARSER_post_tok = 25;
const INT PARSER_if_tok = 17;
const INT PARSER_loop_tok = 22;
const INT PARSER_yield_tok = 47;
const INT PARSER_quit_tok = 29;
const INT PARSER_return_tok = 33;
const INT PARSER_case_tok = 8;
const INT PARSER_typecase_tok = 41;
const INT PARSER_assert_tok = 5;
const INT PARSER_protect_tok = 28;
const INT PARSER_raise_tok = 30;
const INT PARSER_fork_tok = 84;
const INT PARSER_lock_tok = 85;
const INT PARSER_unlock_tok = 86;
const INT PARSER_try_tok = 87;
const INT PARSER_with_tok = 88;
const INT PARSER_par_tok = 96;
const INT PARSER_parloop_tok = 97;
const INT PARSER_then_tok = 38;
const INT PARSER_elsif_tok = 12;
const INT PARSER_else_tok = 11;
const INT PARSER_when_tok = 45;
const INT PARSER_do_tok = 95;
const INT PARSER_attach_tok = 83;
const INT PROG_AS_TBL_load_ratio = 4;
const INT FSETdTP_load_ratio = 4;
const INT TP_ITER_TBL_load_ratio = 4;
const INT FSETIDENT_load_ratio = 4;
const INT FSETTUPIDENTINT_load_rat = 4;
const INT TP_KIND_ext_tp = 4;
const INT ELT_TBL_load_ratio = 4;
const INT TP_KIND_iter_tp = 7;
const INT TP_KIND_rout_tp = 6;
const INT TP_KIND_val_tp = 1;
const INT TP_KIND_ref_tp = 2;
const INT TP_KIND_spr_tp = 5;
const INT FSETAS_FEAT_MOD_load_rat = 4;
const INT SIG_TBL_load_ratio = 4;
const INT FMAPdTPIMPL_load_ratio = 4;
const INT FSETTP_CLASS_load_ratio = 4;
const INT FMAPTP_CLASSFSETTP_CLASS12 = 4;
const INT FMAPTP_CLASSFSETdTP_load = 4;
const INT FMAPdTPIFC_load_ratio = 4;
const INT FMAPdOBNAMESPACE_load_ra = 4;
const INT NAMEMAP_load_ratio = 4;
const INT FMAPSTRITER_INLINE_load_ = 4;
PROG CODE_FILE_prog = ((PROG) NULL);
CGEN CODE_FILE_cgen = ((CGEN) NULL);
STR CODE_FILE_dir = ((STR) NULL);
FMAPSIGAM_ROUT_DEF CODE_FILE_iter_sigs = ((FMAPSIGAM_ROUT_DEF) NULL);
FMAPSTRSTR CODE_FILE_thumbprints = ((FMAPSTRSTR) NULL);
FLISTCODE_FILE CODE_FILE_all = ((FLISTCODE_FILE) NULL);
const INT FMAPdTPCODE_FILE_load_ra = 4;
const INT FMAPSTRINT_load_ratio = 4;
const INT FSETSIG_load_ratio = 4;
const INT TP_ARRAY_quicksort_limit = 10;
MS_RANDOM_GEN RND_s_gen = ((MS_RANDOM_GEN) NULL);
FLTD MS_RANDOM_GEN_ms_m = ((FLTD) 0);
FLTD MS_RANDOM_GEN_ms_md = ((FLTD) 0);
FLTD MS_RANDOM_GEN_ms_a;
FMAPdTPdLAYOUT LAYOUT_TBL_layout_tbl = ((FMAPdTPdLAYOUT) NULL);
FSETBUILTIN_LAYOUT BUILTIN_LAYOUT_layouts = ((FSETBUILTIN_LAYOUT) NULL);
const INT FSETBUILTIN_LAYOUT_load_ = 4;
const INT FMAPdTPdLAYOUT_load_rati = 4;
FSETEXTERNAL_LAYOUT EXTERNAL_LAYOUT_layouts = ((FSETEXTERNAL_LAYOUT) NULL);
const INT FSETEXTERNAL_LAYOUT_load = 4;
FSETABSTRACT_LAYOUT ABSTRACT_LAYOUT_layouts = ((FSETABSTRACT_LAYOUT) NULL);
const INT FSETABSTRACT_LAYOUT_load = 4;
FSETBOUND_TYPE_LAYOUT BOUND_TYPE_LAYOUT_layout1 = ((FSETBOUND_TYPE_LAYOUT) NULL);
const INT FSETBOUND_TYPE_LAYOUT_lo = 4;
const INT FMAPIDENTdTP_load_ratio = 4;
FSETVALUE_CLASS_LAYOUT VALUE_CLASS_LAYOUT_layou1 = ((FSETVALUE_CLASS_LAYOUT) NULL);
const INT FSETVALUE_CLASS_LAYOUT_l = 4;
FSETCLASS_LAYOUT CLASS_LAYOUT_layouts = ((FSETCLASS_LAYOUT) NULL);
const INT FSETCLASS_LAYOUT_load_ra = 4;
const INT FSETdLAYOUT_load_ratio = 4;
const INT FMAPSIGAM_ROUT_DEF_load_ = 4;
const INT FMAPAM_ROUT_DEFFLISTAM_I8 = 4;
FLT FLT_log2_e;
const INT FSETAM_GLOBAL_EXPR_load_ = 4;
FMAPAM_BND_CREATE_EXPRBO BOUND_OBJECT_LAYOUT_layo1 = ((FMAPAM_BND_CREATE_EXPRBO) NULL);
const INT FMAPAM_BND_CREATE_EXPRBO12 = 4;
const INT FSETAM_ROUT_DEF_load_rat = 4;
const INT ARRAYdTP_quicksort_limit = 10;
CALL_TP_VOID CALL_TP_VOID_cache = ((CALL_TP_VOID) NULL);
CALL_TP_CREATE CALL_TP_CREATE_cache = ((CALL_TP_CREATE) NULL);
CALL_TP_ARRAY CALL_TP_ARRAY_cache = ((CALL_TP_ARRAY) NULL);
const INT TP_KIND_abs_tp = 3;
INT INLINE_ATTR_READ_inlined1 = ((INT) 0);
INT INLINE_ATTR_WRITE_inline1 = ((INT) 0);
INT INLINE_GLOBAL_READ_inlin1 = ((INT) 0);
INT INLINE_INT_FOLD_inlined = ((INT) 0);
INT INLINE_ROUT_inlined = ((INT) 0);
const INT FMAPAM_LOCAL_EXPRAM_LOCA7 = 4;
INT INLINE_VATTR_WRITE_inlin1 = ((INT) 0);
INT INLINE_ITER_inlined = ((INT) 0);
const INT FMAPIDENTAM_GLOBAL_EXPR_11 = 4;
const INT FMAPdTPFMAPIDENTAM_GLOBA12 = 4;
const BOOL TRANS_do_direct_export = TRUE;
const BOOL TRANS_do_helper_import = TRUE;
const INT TRANS_import_code = 1;
const INT TRANS_export_code = 2;
INT IDENT_tmp_count = ((INT) 0);
const INT TRANS_par_code = 12;
const INT TRANS_frk_code = 11;
const INT TRANS_att_code = 13;
const BOOL TRANS_do_helper_export = FALSE;
const INT WEIGH_CODE_assign_weight = 1;
const INT WEIGH_CODE_rout_call_wei = 2;
const INT WEIGH_CODE_if_weight = 1;
const INT WEIGH_CODE_iter_call_wei = 4;
INT INLINE_ITER_iters = ((INT) 0);
INT INLINE_ATTR_READ_routine1 = ((INT) 0);
INT INLINE_VATTR_WRITE_routi1 = ((INT) 0);
INT INLINE_GLOBAL_READ_routi1 = ((INT) 0);
INT INLINE_ATTR_WRITE_routin1 = ((INT) 0);
INT INLINE_ROUT_routines = ((INT) 0);
PROG AS_OUT_prog = ((PROG) NULL);
INT AS_OUT_indent = ((INT) 0);
const INT FMAPdTPINT_load_ratio = 4;
const INT FSETTUPSIGSIG_load_ratio = 4;
const INT FMAPSIGSTR_load_ratio = 4;
const INT ARRAYSTR_quicksort_limit = 10;
const INT CODE_FILE_ARRAY_quicksor1 = 10;
FLISTCODE_FILE CODE_FILE_todo = ((FLISTCODE_FILE) NULL);
FLISTdLAYOUT CODE_FILE_layout_order = ((FLISTdLAYOUT) NULL);
FLISTSTR CODE_FILE_layout_text = ((FLISTSTR) NULL);
FMAPAM_ROUT_DEFFRAME_LAY FRAME_LAYOUT_layouts = ((FMAPAM_ROUT_DEFFRAME_LAY) NULL);
const INT FMAPAM_ROUT_DEFFRAME_LAY12 = 4;
FMAPSIGARG_LAYOUT ARG_LAYOUT_layouts = ((FMAPSIGARG_LAYOUT) NULL);
const INT LAYOUT_ARRAY_quicksort_l = 10;
FMAPSIGABSTRACT_FRAME_LA ABSTRACT_FRAME_LAYOUT_la1 = ((FMAPSIGABSTRACT_FRAME_LA) NULL);
const INT FMAPSIGABSTRACT_FRAME_LA12 = 4;
const INT LAYOUT_ARR_quicksort_lim = 10;
const INT ARRAYFSTR_quicksort_limi = 10;
